<script>
	import { IsTerminalOpen, TerminalMsg, TerminalLogFunc } from '$lib/stores';
	import PlusOutline from 'flowbite-svelte-icons/PlusOutline.svelte';
	import MinusOutline from 'flowbite-svelte-icons/MinusOutline.svelte';
	import TrashBinOutline from 'flowbite-svelte-icons/TrashBinOutline.svelte';

	let terminalHeight = $state('h-[40vh]');

	TerminalLogFunc('Initialized Terminal');
	TerminalLogFunc(
		'1 created\n' + JSON.stringify(JSON.parse('[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]'), null, 4)
	);
	TerminalLogFunc(
		'2 created\n' + JSON.stringify(JSON.parse('[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]'), null, 4)
	);
	TerminalLogFunc(
		'3 created\n' + JSON.stringify(JSON.parse('[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]'), null, 4)
	);
	TerminalLogFunc(
		'4 created\n' + JSON.stringify(JSON.parse('[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]'), null, 4)
	);
	TerminalLogFunc(
		'5 created\n' + JSON.stringify(JSON.parse('[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]'), null, 4)
	);
	TerminalLogFunc(
		'6 created\n' + JSON.stringify(JSON.parse('{"name": "asd", "roll": 21, "sec": null}'), null, 4)
	);
</script>

<div
	class="{$IsTerminalOpen === true
		? ''
		: 'hidden'} terminal font-[monospace] {terminalHeight} duration-100"
>
	<div
		class="terminal-header flex justify-between items-center py-1 px-2 surface-ios-cont font-bold"
	>
		<span>Log Terminal</span>
		<div class="flex flex-row gap-2">
			<button onclick={() => (terminalHeight = 'h-[calc(100vh-90px)]')}>
				<PlusOutline class="w-5 h-5 ms-2" />
			</button>
			<button onclick={() => (terminalHeight = 'h-[40vh]')}>
				<MinusOutline class="w-5 h-5 ms-2" />
			</button>
		</div>
		<div class="flex flex-row gap-2">
			<button onclick={() => ($TerminalMsg = [])}>
				<TrashBinOutline class="w-5 h-5 ms-2" />
			</button>
			<button
				class="bg-transparent border-0 cursor-pointer font-[12px]"
				onclick={() => ($IsTerminalOpen = !$IsTerminalOpen)}
			>
				&#10005;
			</button>
		</div>
	</div>
	<div
		class="h-[calc(100%-28px)] overflow-auto whitespace-pre-wrap breakwr surface-ios-cont gap-[1px] flex flex-col-reverse"
		id="terminal-output"
	>
		{#each $TerminalMsg as msg}
			<pre class="text-[12px]">{@html msg}</pre>
		{/each}
	</div>
</div>
